<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link href="css/bootstrap.min.css" rel="stylesheet">
    <title>bluez-avrcp-volume</title>
  </head>
  <body>
    
    <main role="main" class="container" style="margin-top: 40px; margin-bottom: 40px">
      <h2>bluez-avrcp-volume <small class="text-muted">manual</small></h2>
      <h3><span class="badge badge-info">medium</span></h3>

      <div class="card" style="margin-top: 20px">
	<div class="card-body">
	  <dl class="row">
	    <dt class="col-sm-3">Image Types:</dt>
	    <dd class="col-sm-9">basesdk-amd64 / hmi-amd64 / sdk-amd64</dd>
	    <dt class="col-sm-3">Image Deployment:</dt>
	    <dd class="col-sm-9">APT</dd>
	    <dt class="col-sm-3">Type:</dt>
	    <dd class="col-sm-9">functional</dd>
	  </dl>

      <h4>Description</h4>
      <p>Test the AVRCP volume up and down commands.</p>

      
      <hr />
      <h4>Resources</h4>
      <ul>
      
      <li>A Bluetooth adapter</li>
      
      <li>An A2DP Source and AVRCP capable phone (Nokia N9 — do not use an Android 4.2 phone as their Bluetooth AVRCP support is broken)</li>
      
      <li>Note that you do not need to play any music on the phone; nor do you need to have headphones or a speaker plugged into the Apertis device.</li>
      
      </ul>
      

      
      <hr />
      <h4>Pre Conditions</h4>
      <ol>
      
      
  <li class="mb-sm-2">Ensure Rootfs is remounted as read/write.</li>
  <p><kbd>$ sudo mount -o remount,rw /</kbd></p>
  <li class="mb-sm-2">Install dependencies</li>
  <p><kbd>$ sudo apt install apertis-tests python3-dbus python3-gi</kbd></p>
  <li class="mb-sm-2">Restart the system to restore the filesystem state to read-only before running the test.</li>
  <p><kbd>$ sudo reboot</kbd></p>

      
      
      
      </ol>
      

      <hr />
      <h4>Execution Steps</h4>
      <ol>
      
      <li class="mb-sm-2">Ensure PulseAudio is activated:</li>
      
      
      
      
      
      
      <p><kbd>$ pactl stat</kbd></p>
      
      
      
      
      <li class="mb-sm-2">Run btmon before any connection happens:</li>
      
      
      
      
      
      
      <p><kbd>$ sudo btmon  | grep -A4 &#39;AV/C: Control&#39;</kbd></p>
      
      
      
      
      <li class="mb-sm-2">Start simple agent:</li>
      
      
      
      
      
      
      <p><kbd>$ /usr/lib/chaiwala-tests/bluez/simple-agent -y</kbd></p>
      
      
      
      
      <li class="mb-sm-2">Pair both devices initiating from the phone side</li>
      
      
      
      
      
      <li class="mb-sm-2">Pay attention to the simple-agent window as it requires input during the pairing process.</li>
      
      
      
      
      
      <li class="mb-sm-2">In another terminal, execute (You can get the Bluetooth device address by running hcitool scan):</li>
      
      
      
      
      
      
      <p><kbd>$ /usr/lib/chaiwala-tests/bluez/test-avrcp.py -i hci0 device_address</kbd></p>
      
      
      
      
      </ol>

      <hr />
      <h4>Expected</h4>
      
      <p class="mt-sm-3">If success, the following output should be generated by btmon:</p>
      
      
      
      
      
      
      
      <p class="mb-sm-0 pl-sm-3"><samp>AV/C: Control: address 0x48 opcode 0x7c</samp></p><p class="mb-sm-0 pl-sm-3"><samp>Subunit: Panel</samp></p><p class="mb-sm-0 pl-sm-3"><samp>Opcode: Passthrough</samp></p><p class="mb-sm-0 pl-sm-3"><samp>Operation: 0x42 (VOLUME DOWN Pressed)</samp></p><p class="mb-sm-0 pl-sm-3"><samp>Length: 0x00</samp></p><p class="mb-sm-0 pl-sm-3"><samp>--</samp></p><p class="mb-sm-0 pl-sm-3"><samp>AV/C: Control: address 0x48 opcode 0x7c</samp></p><p class="mb-sm-0 pl-sm-3"><samp>Subunit: Panel</samp></p><p class="mb-sm-0 pl-sm-3"><samp>Opcode: Passthrough</samp></p><p class="mb-sm-0 pl-sm-3"><samp>Operation: 0x41 (VOLUME UP Pressed)</samp></p><p class="mb-sm-0 pl-sm-3"><samp>Length: 0x00</samp></p>
      
      
      

      

	</div>
      </div>

      
    </main>

  </body>
</html>